<?php
require 'vendor/autoload.php';

use i18n\i18n;

$i18n = new i18n("en", "en", ["en", "es", "sv", "he", "fr", "ar","zh-cn","zh", "ja", "bn", "hi", "pt", "ru", "de", "id", "pl", "id", "tr", "vi", "ko", "ha", "mr", "te", "it", "fa", "gu", "yo", "am", "tl", "th", "uk", "ro", "bg", "nl", "sr", "el", "cs", "hu", "hr", "da", "no", "fi", "sq", "sk", "lt", "bs", "sl", "lv"]);

ob_start();
session_start();

$refname = $i18n->get("title");
if(isset($user['name'])) $refname =  $user['name'];  
if(isset($_GET['name'])) $refname =  $_GET['name']; 


// 86400 = 1 day
if (isset($_GET['tracking'])) {
	setcookie('tracking', $_GET['tracking'], time() + (86400 * 30), "/");
}
if (isset($_GET['tag'])) {
	setcookie('tag', $_GET['tag'], time() + (86400 * 30), "/");
}
if (isset($_GET['affid'])){
	setcookie('affid', $_GET['affid'], time() + (86400 * 30), "/");
}

if(isset($_GET['affid'])) $affid = $_GET['affid'];
if(isset($_GET['tag'])) $tag = $_GET['tag'];
if(isset($_GET['sub1'])) $affid = $_GET['sub1'];
if(isset($_GET['sub2'])) $affid = $_GET['sub2'];

$lng = 'en';


if (isset($_GET['tracking'])) {
	$tag = $_GET['tracking'];
}
if (isset($_GET['cid'])) {
	$tag = $_GET['cid'];
}
if (isset($_GET['sid'])) {
	$affid = $_GET['sid'];
}
if (isset($_GET['campid'])) {
	$campid = $_GET['campid'];
}
if (isset($_GET['zid'])) {
	$zid = $_GET['zid'];
}
if (isset($_GET['lng'])) {
	$lng = $_GET['lng'];
	$i18n->setLang($lng);
}else{
    $lng = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
	$i18n->setLang($lng);  
}
if (isset($_GET['ref'])) {
	$ref = $_GET['ref'];
}
$ip = $_SERVER['REMOTE_ADDR'];
$geo = "";
if (function_exists("geoip_country_code_by_name")) {
	$geo = geoip_country_code_by_name($ip);
}
?>

<!DOCTYPE html>
<html lang="<?= $lng ?>" <?if($lng == "fa" || $lng ==  "ar") echo "dir=rtl" ?>>

<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="X-UA-Compatible" content="ie=edge">
	<meta name="description" content="<?= $i18n->get("share") ?> <?= $refname ?> <?= $i18n->get("how") ?>">
	<meta name="image" content="/favicon.ico">
	<meta property="og:site_name" content="<?= $i18n->get("title"); ?>">
    <meta property="og:title" content="<?= $i18n->get("sharetitle"); ?>" />
    <meta property="og:description" content="<?= $i18n->get("share") ?> <?= $refname ?> <?= $i18n->get("how") ?>" />
    <meta property="og:image" itemprop="image" content="like.png">
    <meta property="og:type" content="website" />
    <meta property="og:updated_time" content="<?php echo time(); ?>" />
	<title>
		<?= $i18n->get("title"); ?>
	</title>
	<link rel="stylesheet" href="css/styles.min.css">
	<script>
		var emailLink;
		var redirectLink;

		function formSubmit() {

			// Show loader
			$("#submit_button").hide();
			$("#loader").show();

			let firstName = $('#firstNameInput').val();
			let lastName = $('#lastNameInput').val();
			let phone = $('#phoneInput').val();
			let email = $('#emailInput').val();

			if (firstName !== "" && email !== "") {
				emailLink = email.split("@")[1];
				
				console.log("TUKAJ");

				$.ajax({
					url: "api.php",
					dataType: "json",
					data: {
					    "firstName": firstName,
						"lastName": lastName,
						"phone": phone,
						"email": email,
						"lng": "<?php echo $lng ?>",
						"geo": "<?php echo $geo ?>",
						"link": window.location.href,
						"affid": "<?php echo $affid ?>",
						"tag": "<?php echo $tag ?>",
						"sub1": "<?php echo $sub1 ?>",
						"sub2": "<?php echo $sub2 ?>",
						"ref": "<?php echo $ref ?>",
						"zid": "<?php echo $zid ?>",
						"campid": "<?php echo $campid ?>",
					},
					method: 'GET',
					success: function(data) {
						redirectLink = data.redirect;

						$(".content__s_2").slideUp();
						$(".content__s_3").slideDown();
					},
					error: function(data) {
						console.error(data.responseJSON);
						$("#errorResponse").html(data.responseJSON.error);
						$(".content__s_2").slideUp();
						$(".content__s_4").slideDown();
					}
				});
			}

			return false;
		}

		function goToMail() {
			window.location.href = "https://" + emailLink;
		}

		function redirect() {
			window.location.href = redirectLink;
		}

		function goBack() {
			$("#submit_button").show();
			$("#loader").hide();

			$('#emailInput').val("");

			$(".content__s_4").slideUp();
			$(".content__s_2").slideDown();
		}
	</script>
	<style>
		.loader {
			display: none;
			border: 16px solid #ffffff;
			border-top: 16px solid #00e871;
			border-radius: 50%;
			width: 80px;
			height: 80px;
			animation: spin 2s linear infinite;
		}

		@keyframes spin {
			0% {
				transform: rotate(0deg);
			}

			100% {
				transform: rotate(360deg);
			}
		}
	</style>

</head>

<body>
	<div class="wrap">
		<div class="bg"></div>

		<div class="content">

			<div class="content__l1">
				<div class="content__s content__s_active">
				<span class=content__highlight> <?= $i18n->get("free"); ?></span>
				<?= $i18n->get("headline"); ?>
				</div>
			</div>

			<div class="content__l2">

				<div class="content__s content__s_active center">
					<span class="content__timer"></span>
				</div>

			</div>

			<div class="content__l3">

				<form action="" method="post" class="content__form" onsubmit="return formSubmit();">

					<div class="content__s content__s_active content__s_1">
						<?= $i18n->get("q1") ?>
						<div class="content__buttons">
							<button type="button" class="content__button content__button_yes content__button_go" data-step="1">
								<?= $i18n->get("wallet"); ?>
							</button>
							<button type="button" class="content__button content__button_yes content__button_go" data-step="1">
							<?= $i18n->get("account"); ?>
							</button>
						</div>
					</div>


					<div class="content__s content__s_2">
						<?= $i18n->get("q2") ?>
						<div class="content__input-group">
						    
						<div class="content__input-group">
						<div>
								<img src="images/user-regular.svg" alt="" class="content__icn-envelope">
								<input id="firstNameInput" required type="text" name="name" value="" placeholder="<?= $i18n->get("fname"); ?>" class="content__input">
							</div>
						</div>
						<div>
								<img src="images/user-regular.svg" alt="" class="content__icn-envelope">
								<input id="lastNameInput" required type="text" name="name" value="" placeholder="<?= $i18n->get("lname"); ?>" class="content__input">
							</div>
						</div>
						<div class="content__input-group">
							<div>
								<img src="images/phone-solid.svg" alt="" class="content__icn-envelope">
								<input id="phoneInput" required type="tel" name="phone" value="" placeholder="<?= $i18n->get("phone"); ?>"  class="content__input">
							</div>
						</div>
						<div class="content__input-group">
							<div>
								<img src="images/envelope-regular.svg" alt="" class="content__icn-envelope">
								<input id="emailInput" required type="email" name="email" value="" placeholder="Email" class="content__input">
							</div>
						</div>
						<br>

						<input type="hidden" name="tag" value="<?php echo $_GET['tag'] ?>">
						<input type="hidden" name="affid" value="<?php echo $_GET['affid'] ?>">
						<input type="hidden" name="lp" value="<?php echo $_GET['lp'] ?>">

						<div class="center_content">

							<button type="submit" name="submit" class="content__button content__button_submit" id="submit_button">
								<?= $i18n->get("content_testafterlead") ?>
							</button>

							<div id="loader" class="loader"></div>
						</div>

						<br>
						<?php echo $text3 ?>

					</div>


					<div class="content__s content__s_3"><b>
							<center></center>
							</be><?= $i18n->get("content_wait") ?>
							<div class="content__buttons">
								<!--<button class="content__button" onclick="goToMail();">
								<?= $i18n->get("content_checkmail") ?>
								<br>
							</button>-->
								&nbsp;

								<button class="content__button" onclick="redirect();">
									<?= $i18n->get("content_redirect") ?>
								</button>
							</div>
							<br><br>
							*<?= $i18n->get("content_check_spam") ?>
					</div>

					<div class="content__s content__s_4">
						<div class="center_content warning">
							<?= $i18n->get("q3") ?>&nbsp;(<span id="errorResponse"></span>)
						</div>
						<br>
						<div class="center_content">
							<button class="content__button" onclick="goBack();">
								<?= $i18n->get("content_retry") ?>
							</button>
						</div>
					</div>

				</form>

			</div>

		</div>

	</div>

	</div>

	</div>

	<script src="js/scripts.min.js"></script>
	
<!-- Google tag (gtag.js) -->
<script async src="https://www.googletagmanager.com/gtag/js?id=G-FP1KMCYZZN"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'G-FP1KMCYZZN');
</script>
    
    
</body>

</html>